'
'  MEMTEST.BAS
'
'  Sample Program Written by Don Dickinson
'  Hereby public domain. Do with it as you wish.
'  No guarantee, use at your own risk.
'
'  Purpose:
'
'  1. Demonstrate An Application that receives shared
'     data from another application via the SendMessage Call.
'     The sister application is consend.bas, consend.exe.
'     This application takes a command line of text that
'     is to be added to the list box in this app.
'
'  2. Demonstrates the use of a simple status bar at the
'     bottom of a window.
'
'  3. Shows some beginning steps to using the ListView
'     Common Control in a PB5 application.
'
'
$DIM ALL
$COMPILE EXE

$INCLUDE "WIN32API.INC"
$INCLUDE "COMMCTRL.INC"
$OPTION VERSION4

%ADD_LISTITEM     = 100

%ID_LISTVIEW      = 900

GLOBAL gInst    AS LONG
GLOBAL gMain    AS LONG
GLOBAL gList    AS LONG
GLOBAL gBrush   AS LONG
GLOBAL gStat    AS LONG

FUNCTION WinMain (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

  LOCAL Msg         AS tagMsg
  LOCAL wndclass    AS WndClassEx
  LOCAL szClassName AS ASCIIZ * 80
  LOCAL hWnd        AS LONG
  LOCAL hMenu       AS LONG

  gInst                  = hInstance
  szClassName            = "Test_WM_COPYDATA"

  gBrush = CreateSolidBrush (GetSysColor(%COLOR_BTNFACE))

  wndclass.cbSize        = SIZEOF(WndClass)
  wndclass.style         = %CS_HREDRAW OR %CS_VREDRAW
  wndclass.lpfnWndProc   = CODEPTR( WndProc )
  wndclass.cbClsExtra    = 0
  wndclass.cbWndExtra    = 0
  wndclass.hInstance     = hInstance
  wndclass.hIcon         = LoadIcon( hInstance, "PROGRAM" )
  wndclass.hCursor       = LoadCursor( %NULL, BYVAL %IDC_ARROW )
  wndclass.hbrBackground = gBrush
  wndclass.lpszMenuName  = %NULL
  wndclass.lpszClassName = VARPTR( szClassName )
  wndclass.hIconSm       = LoadIcon( hInstance, BYVAL %IDI_APPLICATION )

  RegisterClassEx wndclass

  ' Create a window using the registered class
  gMain = CreateWindow(szClassName, _               ' window class name
                          "Run addlist.exe to add items to the list.", _ ' window caption
                          %WS_OVERLAPPEDWINDOW, _      ' window style
                          %CW_USEDEFAULT, _            ' initial x position
                          %CW_USEDEFAULT, _            ' initial y position
                          %CW_USEDEFAULT, _            ' initial x size
                          %CW_USEDEFAULT, _            ' initial y size
                          %HWND_DESKTOP, _             ' parent window handle
                          hMenu, _                     ' window menu handle
                          hInstance, _                 ' program instance handle
                          BYVAL %NULL)                 ' creation parameters

  ShowWindow gMain, iCmdShow
  UpdateWindow gMain


  WHILE GetMessage(Msg, %NULL, 0, 0)
    TranslateMessage Msg
    DispatchMessage Msg
  WEND

  DeleteObject gBrush

  FUNCTION = msg.wParam

END FUNCTION  ' WinMain


FUNCTION WndProc (BYVAL hWnd AS LONG, BYVAL wMsg AS LONG, _
                  BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

   Dim zString as ASCIIZ * 100
   DIm pzString as ASCIIZ PTR
   Dim rListItem as LV_ITEM
   Dim pcol as LV_COLUMN
   Dim foo as Long
   Dim a%
   Dim rRect as RECT
   Dim rListInfo as LV_DISPINFO PTR
   Dim rInfo as NM_LISTVIEW PTR
   Dim rRecData as COPYDATASTRUCT PTR
   Dim ptrData as ASCIIZ PTR

   SELECT CASE wMsg

      CASE %WM_CREATE

         SetCursor LoadCursor( %NULL, BYVAL %IDC_WAIT )
         foo= 0

         InitCommonControls

         '- Create the listview control
         gList = CreateWindowEx(0, _
               "SysListView32", "", _
               %WS_CHILD or %WS_VISIBLE or %LVS_REPORT or %LVS_SHOWSELALWAYS _
               or %LVS_ALIGNTOP or %LVS_SINGLESEL or %LVS_ALIGNLEFT or %WS_BORDER, _
               30, 30, 500, 200, hWnd, %ID_LISTVIEW, gInst, foo)

         '- Create the status bar at the bottom of the screen.
         gStat = CreateStatusWindow (%CCS_BOTTOM or %WS_VISIBLE or _
               %WS_CHILD or %WS_CLIPSIBLINGS or %SBARS_SIZEGRIP, _
               "Status Bar",hWnd, 2)
   
         
         '- Create Columns in the listview
         pcol.mask = %LVCF_FMT or %LVCF_WIDTH or %LVCF_TEXT or %LVCF_SUBITEM
         pcol.fmt = %LVCF_TEXT
         pcol.cx = 100
         zString = "Column 1 "
         pcol.pszText = VARPTR(zString)
         pcol.cchTextMax = 100
         pcol.iSubItem = 0
         ListView_InsertColumn gList, 0, pcol

         pcol.mask = %LVCF_SUBITEM or %LVCF_FMT or %LVCF_WIDTH or %LVCF_TEXT
         pcol.fmt = %LVCF_TEXT
         pcol.cx = 100
         zString = "Column 2 "
         pcol.pszText = VARPTR(zString)
         pcol.cchTextMax = 100
         pcol.iSubItem = 1
         ListView_InsertColumn gList, 1, pcol
         SetCursor LoadCursor( %NULL, BYVAL %IDC_ARROW )

      CASE %WM_NOTIFY

         '- I display a silly message box if the
         '  user clicks on the column header.
         '  This is for demonstration purposes
         '  only. If you want to sort the
         '  list based on this, you need
         '  a callback function in your code.
         '
         Select Case wParam
            Case %ID_LISTVIEW
               rListInfo = lParam
   
               if @rListInfo.hdr.code = %LVN_COLUMNCLICK then
                  MsgBox "Click !!!"
               end if
         End Select
         
      CASE %WM_PAINT
      CASE %WM_SIZE
         GetWindowRect gStat, rRect

         '- Move the status window
         MoveWindow gStat, 0, _
                    LOWRD(lParam) - (rRect.nBottom - rRect.nTop), _
                    HIWRD(lParam), HIWRD(lParam), %True


      CASE %WM_DESTROY
         PostQuitMessage 0
         FUNCTION = 0
         EXIT FUNCTION

      CASE %WM_COPYDATA

         rRecData = lParam

         '- What type of message is this. The
         '  %ADD_LISTITEM constant is one that
         '  I define at the beginning of this
         '  program.
         '
         if @rRecData.dwData = %ADD_LISTITEM then
            ptrData = @rRecData.lpData
            SetCursor LoadCursor( %NULL, BYVAL %IDC_WAIT )

            '- Add 100 items to the list every time
            '  this message is received.
            '
            for a% = 1 to 100
               zString = @ptrData
               rListItem.Mask = %LVIF_TEXT
               rListItem.iItem = ListView_GetItemCount(gList)
               rListItem.iSubItem = 0
               rListItem.state = 0
               rListItem.stateMask = 0
               rListItem.pszText = VARPTR(zString)
               rListItem.cchTextMax = 100
               rListItem.iImage = 0
               rListItem.lParam = 0
               ListView_InsertItem gList, rListItem
               zString = str$(rListItem.iItem) + ": SubItem 1"
               ListView_SetItemText gList, rListItem.iItem, 1, zString
            Next a%
            SetWindowText gStat, "100 items added: " + @ptrData
            SetCursor LoadCursor( %NULL, BYVAL %IDC_ARROW )
         End If

   END SELECT

   FUNCTION = DefWindowProc(hWnd, wMsg, wParam, lParam)

END FUNCTION

